diff --git a/src/interfaces/libpq/fe-connect.c b/src/interfaces/libpq/fe-connect.c
index eea9c6b..6528f77 100644
--- a/src/interfaces/libpq/fe-connect.c
+++ b/src/interfaces/libpq/fe-connect.c
@@ -4216,9 +4216,12 @@ conninfo_parse(const char *conninfo, PQExpBuffer errorMessage,
 				}
 				if (*cp == '\'')
 				{
-					*cp2 = '\0';
 					cp++;
-					break;
+					if (*cp != '\'')
+					{
+						*cp2 = '\0';
+						break;
+					}
 				}
 				*cp2++ = *cp++;
 			}
